## pcl 1.8.0+dfsg1

=== CMakeLists.txt ===
### ---[ PCL global CMake
cmake_minimum_required(VERSION 2.8 FATAL_ERROR)

if(POLICY CMP0017)
  # Do not include files in CMAKE_MODULE_PATH from files
  # in CMake module directory. Fix MXE build
  cmake_policy(SET CMP0017 NEW)
endif()

if(POLICY CMP0020 AND (WIN32 AND NOT MINGW))
  cmake_policy(SET CMP0020 NEW) # Automatically link Qt executables to qtmain target on Windows
endif()

if(POLICY CMP0048)
  cmake_policy(SET CMP0048 OLD) # do not use VERSION option in project() command
endif()

if(POLICY CMP0054)
  cmake_policy(SET CMP0054 OLD) # Silent warnings about quoted variables
endif()

set(CMAKE_CONFIGURATION_TYPES "Debug;Release" CACHE STRING "possible configurations" FORCE)

# In case the user does not setup CMAKE_BUILD_TYPE, assume it's RelWithDebInfo
if("${CMAKE_BUILD_TYPE}" STREQUAL "")
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type default to RelWithDebInfo, set to Release to improve performance" FORCE)
endif("${CMAKE_BUILD_TYPE}" STREQUAL "")

project(PCL)
string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)

### ---[ Find universal dependencies
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/" ${CMAKE_MODULE_PATH})

# ---[ Include pkgconfig
include (FindPkgConfig)

# ---[ Release/Debug specific flags
if(CMAKE_BUILD_TYPE STREQUAL "Release" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
  add_definitions("-DBOOST_DISABLE_ASSERTS -DEIGEN_NO_DEBUG")
endif()
if(WIN32 AND NOT MINGW)
  if(NOT DEFINED CMAKE_DEBUG_POSTFIX)
    set(CMAKE_DEBUG_POSTFIX "_debug")
  endif()
  if(NOT DEFINED CMAKE_RELEASE_POSTFIX)
    set(CMAKE_RELEASE_POSTFIX "_release")
  endif()
  if(NOT DEFINED CMAKE_RELWITHDEBINFO_POSTFIX)
    set(CMAKE_RELWITHDEBINFO_POSTFIX "_release")
  endif()
  if(NOT DEFINED CMAKE_MINSIZEREL_POSTFIX)
    set(CMAKE_MINSIZEREL_POSTFIX "_release")
  endif()
endif()

# ---[ special maintainer mode
SET(CMAKE_CXX_FLAGS_MAINTAINER "-pedantic -Wno-variadic-macros -Weffc++ -Wno-long-long" CACHE STRING
    "Flags used by the C++ compiler during maintainer builds."
    FORCE)
SET(CMAKE_C_FLAGS_MAINTAINER "-pedantic -Wno-variadic-macros -Weffc++ -Wno-long-long" CACHE STRING
    "Flags used by the C compiler during maintainer builds."
    FORCE)
SET(CMAKE_EXE_LINKER_FLAGS_MAINTAINER
    "-Wl,--warn-unresolved-symbols,--warn-once" CACHE STRING
    "Flags used for linking binaries during maintainer builds."
    FORCE)
SET(CMAKE_SHARED_LINKER_FLAGS_MAINTAINER
    "-Wl,--warn-unresolved-symbols,--warn-once" CACHE STRING
    "Flags used by the shared libraries linker during maintainer builds."
    FORCE)
MARK_AS_ADVANCED(
    CMAKE_CXX_FLAGS_MAINTAINER
    CMAKE_C_FLAGS_MAINTAINER
    CMAKE_EXE_LINKER_FLAGS_MAINTAINER
    CMAKE_SHARED_LINKER_FLAGS_MAINTAINER )
# Update the documentation string of CMAKE_BUILD_TYPE for GUIs
SET(CMAKE_BUILD_TYPE "${CMAKE_BUILD_TYPE}" CACHE STRING
    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel Maintainer."
    FORCE)

# Compiler identification
# Define a variable CMAKE_COMPILER_IS_X where X is the compiler short name.
# Note: CMake automatically defines one for GNUCXX, nothing to do in this case.
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  set(CMAKE_COMPILER_IS_CLANG 1)
elseif(__COMPILER_PATHSCALE)
  set(CMAKE_COMPILER_IS_PATHSCALE 1)
elseif(MSVC)
  set(CMAKE_COMPILER_IS_MSVC 1)
endif()

include("${PCL_SOURCE_DIR}/cmake/pcl_verbosity.cmake")
include("${PCL_SOURCE_DIR}/cmake/pcl_targets.cmake")
include("${PCL_SOURCE_DIR}/cmake/pcl_options.cmake")

# Enable verbose timing display?
if(CMAKE_TIMING_VERBOSE AND UNIX)
  set_property(GLOBAL PROPERTY RULE_MESSAGES OFF)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CMAKE_SOURCE_DIR}/cmake/custom_output.sh")
endif(CMAKE_TIMING_VERBOSE AND UNIX)

# check for SSE flags
include("${PCL_SOURCE_DIR}/cmake/pcl_find_sse.cmake")
if (PCL_ENABLE_SSE)
  PCL_CHECK_FOR_SSE()
endif (PCL_ENABLE_SSE)

# ---[ Unix/Darwin/Windows specific flags
if(CMAKE_COMPILER_IS_GNUCXX)
  if("${CMAKE_CXX_FLAGS}" STREQUAL "")
    SET(CMAKE_CXX_FLAGS "-Wall -Wextra -Wno-unknown-pragmas -fno-strict-aliasing -Wno-format-extra-args -Wno-sign-compare -Wno-invalid-offsetof -Wno-conversion ${SSE_FLAGS}")

    # Enable -Wabi for GCC > 4.3, and -Wno-deprecated for GCC < 4.3
    # to disable a lot of warnings which are not fixable
    execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
    if (GCC_VERSION VERSION_GREATER 4.3)
      message(STATUS "-- GCC > 4.3 found, enabling -Wabi")
      SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wabi")
    else()
      message(STATUS "-- GCC < 4.3 found, enabling -Wno-deprecated")
      SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated")
    endif ()
  endif()

  if(NOT ANDROID)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")
  endif(NOT ANDROID)

  if("${CMAKE_SHARED_LINKER_FLAGS}" STREQUAL "" AND NOT CMAKE_SYSTEM_NAME STREQUAL "Darwin")
    SET(CMAKE_SHARED_LINKER_FLAGS "-Wl,--as-needed")
  endif()

  if(WIN32)
    if(PCL_SHARED_LIBS)
      SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--export-all-symbols -Wl,--enable-auto-import")
      if (MINGW)
        add_definitions("-DBOOST_THREAD_USE_LIB")
        SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--allow-multiple-definition")
      endif()
    else(PCL_SHARED_LIBS)
      add_definitions("-DBOOST_LIB_DIAGNOSTIC -DBOOST_THREAD_USE_LIB")
    endif(PCL_SHARED_LIBS)
  endif()
endif()

if(CMAKE_COMPILER_IS_MSVC)
  add_definitions("-DBOOST_ALL_NO_LIB -D_SCL_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS -DNOMINMAX -DPCL_ONLY_CORE_POINT_TYPES /bigobj ${SSE_DEFINITIONS}")
  if("${CMAKE_CXX_FLAGS}" STREQUAL " /DWIN32 /D_WINDOWS /W3 /GR /EHsc")	# Check against default flags
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj /EHsc /fp:precise /wd4800 /wd4521 /wd4251 /wd4275 /wd4305 /wd4355 ${SSE_FLAGS}")

    # Add extra code generation/link optimizations
    if(CMAKE_MSVC_CODE_LINK_OPTIMIZATION)
      SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /GL")
      SET(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /LTCG /OPT:REF")
      SET(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /LTCG")
    endif(CMAKE_MSVC_CODE_LINK_OPTIMIZATION)
    # /MANIFEST:NO") # please, don't disable manifest generation, otherwise crash at start for vs2008

    if( MSVC_VERSION GREATER 1500 AND ${CMAKE_VERSION} VERSION_GREATER "2.8.6")
      include(ProcessorCount)
      ProcessorCount(N)
      if(NOT N EQUAL 0)
        SET(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP${N} ")
        SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP${N} ")
      endif()
    endif()
  endif()
endif()

if(CMAKE_COMPILER_IS_PATHSCALE)
  if("${CMAKE_CXX_FLAGS}" STREQUAL "")
    SET(CMAKE_CXX_FLAGS "-Wno-uninitialized -zerouv -pthread -mp")
  endif()
  if("${CMAKE_SHARED_LINKER_FLAGS}" STREQUAL "")
    SET(CMAKE_SHARED_LINKER_FLAGS "-mp")
  endif()
endif()

if(CMAKE_COMPILER_IS_CLANG)
  if("${CMAKE_C_FLAGS}" STREQUAL "")
    SET(CMAKE_C_FLAGS "-Qunused-arguments")
  endif()
  if("${CMAKE_CXX_FLAGS}" STREQUAL "")
    SET(CMAKE_CXX_FLAGS "-ftemplate-depth=1024 -Qunused-arguments -Wno-invalid-offsetof ${SSE_FLAGS}") # Unfortunately older Clang versions do not have this: -Wno-unnamed-type-template-args
    if(APPLE AND WITH_CUDA AND CUDA_FOUND)
      SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libstdc++")
    endif()
  endif()
  SET(CLANG_LIBRARIES "stdc++")
endif()

include("${PCL_SOURCE_DIR}/cmake/pcl_utils.cmake")
set(PCL_VERSION 1.8.0 CACHE STRING "PCL version")
DISSECT_VERSION()
GET_OS_INFO()
SET_INSTALL_DIRS()

if(WIN32)
  set(PCL_RESOURCES_DIR "${PCL_SOURCE_DIR}/resources")
  set(PCL_POINTCLOUDS_DIR "${PCL_RESOURCES_DIR}/pointclouds")
endif(WIN32)

set(PCL_OUTPUT_LIB_DIR "${PCL_BINARY_DIR}/${LIB_INSTALL_DIR}")
set(PCL_OUTPUT_BIN_DIR "${PCL_BINARY_DIR}/${BIN_INSTALL_DIR}")
make_directory("${PCL_OUTPUT_LIB_DIR}")
make_directory("${PCL_OUTPUT_BIN_DIR}")
if(WIN32)
  foreach(config ${CMAKE_CONFIGURATION_TYPES})
    string(TOUPPER ${config} CONFIG)
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${CONFIG} "${PCL_OUTPUT_LIB_DIR}")
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${CONFIG} "${PCL_OUTPUT_BIN_DIR}")
    # ---[ Windows requires DLLs (shared libraries) to be installed in the same directory as executables
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${CONFIG} "${PCL_OUTPUT_BIN_DIR}")
  endforeach(config)
else(WIN32)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${PCL_OUTPUT_LIB_DIR}")
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PCL_OUTPUT_BIN_DIR}")
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PCL_OUTPUT_LIB_DIR}")
endif(WIN32)

# Add an "uninstall" target
configure_file("${PCL_SOURCE_DIR}/cmake/uninstall_target.cmake.in"
               "${PCL_BINARY_DIR}/uninstall_target.cmake" IMMEDIATE @ONLY)
add_custom_target(uninstall "${CMAKE_COMMAND}" -P
                  "${PCL_BINARY_DIR}/uninstall_target.cmake")

###
# this is copy paste form http://www.itk.org/Wiki/CMake_RPATH_handling
# in order to always make a full statement RPATH
###
SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}")
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}" is_system_dir)
IF("${is_system_dir}" STREQUAL "-1")
SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}")
ENDIF("${is_system_dir}" STREQUAL "-1")

### ---[ Find universal dependencies
# the gcc-4.2.1 coming with MacOS X is not compatible with the OpenMP pragmas we use, so disabling OpenMP for it
if((NOT APPLE) OR (NOT CMAKE_COMPILER_IS_GNUCXX) OR (GCC_VERSION VERSION_GREATER 4.2.1) OR (CMAKE_COMPILER_IS_CLANG))
  find_package(OpenMP)
endif()
if(OPENMP_FOUND)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
  message (STATUS "Found OpenMP")
  if(MSVC)
    if(MSVC90)
      set(OPENMP_DLL VCOMP90)
    elseif(MSVC10)
      set(OPENMP_DLL VCOMP100)
    elseif(MSVC11)
      set(OPENMP_DLL VCOMP110)
    elseif(MSVC12)
      set(OPENMP_DLL VCOMP120)
    elseif(MSVC14)
      set(OPENMP_DLL VCOMP140)
    endif(MSVC90)
    if(OPENMP_DLL)
      set(CMAKE_SHARED_LINKER_FLAGS_DEBUG "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} /DELAYLOAD:${OPENMP_DLL}D.dll")
      set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /DELAYLOAD:${OPENMP_DLL}.dll")
    else(OPENMP_DLL)
      message(WARNING "Delay loading flag for OpenMP DLL is invalid.")
    endif(OPENMP_DLL)
  endif(MSVC)
else(OPENMP_FOUND)
  message (STATUS "Not found OpenMP")
endif()

# Eigen (required)
find_package(Eigen REQUIRED)
include_directories(SYSTEM ${EIGEN_INCLUDE_DIRS})
add_definitions(-DEIGEN_USE_NEW_STDVECTOR
                -DEIGEN_YES_I_KNOW_SPARSE_MODULE_IS_NOT_STABLE_YET)
# FLANN (required)
if(NOT PCL_SHARED_LIBS OR (WIN32 AND NOT MINGW))
  set(FLANN_USE_STATIC ON)
endif(NOT PCL_SHARED_LIBS OR (WIN32 AND NOT MINGW))
find_package(FLANN 1.7.0 REQUIRED)
include_directories(${FLANN_INCLUDE_DIRS})

# libusb-1.0
option(WITH_LIBUSB "Build USB RGBD-Camera drivers" TRUE)
if(WITH_LIBUSB)
  find_package(libusb-1.0)
  if(LIBUSB_1_FOUND)
    include_directories("${LIBUSB_1_INCLUDE_DIR}")
  endif(LIBUSB_1_FOUND)
endif(WITH_LIBUSB)

# Dependencies for different grabbers
PCL_ADD_GRABBER_DEPENDENCY("OpenNI" "OpenNI grabber support")
PCL_ADD_GRABBER_DEPENDENCY("OpenNI2" "OpenNI2 grabber support")
PCL_ADD_GRABBER_DEPENDENCY("FZAPI" "Fotonic camera support")
PCL_ADD_GRABBER_DEPENDENCY("Ensenso" "IDS-Imaging Ensenso camera support")
PCL_ADD_GRABBER_DEPENDENCY("davidSDK" "David Vision Systems SDK support")
PCL_ADD_GRABBER_DEPENDENCY("DSSDK" "DepthSense SDK support")
PCL_ADD_GRABBER_DEPENDENCY("RSSDK" "RealSense SDK support")

# metslib
if (PKG_CONFIG_FOUND)
  pkg_check_modules(METSLIB metslib)
  if (METSLIB_FOUND)
    set (HAVE_METSLIB ON)
    include_directories(${METSLIB_INCLUDE_DIRS})
  else()

=== 2d/CMakeLists.txt ===
set(SUBSYS_NAME 2d)
set(SUBSYS_DESC "Point cloud 2d")
set(SUBSYS_DEPS common io filters)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} OPT_DEPS vtk)

PCL_ADD_DOC("${SUBSYS_NAME}")

if(build)

    set(srcs
        src/convolution_2d.cpp 
        )

    set(incs
        "include/pcl/${SUBSYS_NAME}/convolution.h"
        "include/pcl/${SUBSYS_NAME}/kernel.h"
        "include/pcl/${SUBSYS_NAME}/edge.h"
        "include/pcl/${SUBSYS_NAME}/morphology.h"
        )

    set(impl_incs
        "include/pcl/${SUBSYS_NAME}/impl/convolution.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/edge.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/morphology.hpp"
        )

    set(LIB_NAME "pcl_${SUBSYS_NAME}")
    
    if(${VTK_FOUND})
        set(VTK_USE_FILE "${VTK_USE_FILE}" CACHE INTERNAL "VTK_USE_FILE")
        include("${VTK_USE_FILE}")
        set(VTK_IO_TARGET_LINK_LIBRARIES vtkCommon vtkWidgets vtkIO vtkImaging)
    endif(${VTK_FOUND})

    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include" ${VTK_INCLUDE_DIRECTORIES})
    PCL_ADD_LIBRARY("${LIB_NAME}" "${SUBSYS_NAME}" ${srcs} ${incs} ${impl_incs})
    link_directories(${VTK_LINK_DIRECTORIES})
    target_link_libraries("${LIB_NAME}" ${VTK_LIBRARIES} pcl_io)
    PCL_MAKE_PKGCONFIG("${LIB_NAME}" "${SUBSYS_NAME}" "${SUBSYS_DESC}" "${SUBSYS_DEPS}" "" "" "" "")

    #Install include files
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl" ${impl_incs})
    
endif(build)

=== io/CMakeLists.txt ===
set(SUBSYS_NAME io)
set(SUBSYS_DESC "Point cloud IO library")
set(SUBSYS_DEPS common octree)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
if(WIN32)
    PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} OPT_DEPS openni openni2 ensenso davidSDK dssdk rssdk pcap png vtk)
else(WIN32)
    PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} OPT_DEPS openni openni2 ensenso davidSDK dssdk pcap png vtk libusb-1.0)
endif(WIN32)

PCL_ADD_DOC("${SUBSYS_NAME}")

if(build)
    if(WITH_OPENNI2)
        set(IMAGE_INCLUDES
          include/pcl/io/image_metadata_wrapper.h
          include/pcl/io/image.h
          include/pcl/io/image_rgb24.h
          include/pcl/io/image_yuv422.h
          include/pcl/io/image_ir.h
          include/pcl/io/image_depth.h
        )

        set(IMAGE_SOURCES
          src/image_rgb24.cpp
          src/image_yuv422.cpp
          src/image_ir.cpp
          src/image_depth.cpp
        )

        set(OPENNI2_GRABBER_INCLUDES
            include/pcl/io/openni2_grabber.h
            )
        set(OPENNI2_INCLUDES
            include/pcl/io/openni2/openni.h
            include/pcl/io/openni2/openni2_metadata_wrapper.h
            include/pcl/io/openni2/openni2_frame_listener.h
            include/pcl/io/openni2/openni2_timer_filter.h
            include/pcl/io/openni2/openni2_video_mode.h
            include/pcl/io/openni2/openni2_convert.h
            include/pcl/io/openni2/openni2_device.h
            include/pcl/io/openni2/openni2_device_info.h
            include/pcl/io/openni2/openni2_device_manager.h
        )

        set(OPENNI2_GRABBER_SOURCES
            src/openni2_grabber.cpp
            src/openni2/openni2_timer_filter.cpp
            src/openni2/openni2_video_mode.cpp
            src/openni2/openni2_convert.cpp
            src/openni2/openni2_device.cpp
            src/openni2/openni2_device_info.cpp
            src/openni2/openni2_device_manager.cpp
        )

      source_group("OpenNI 2\\Header Files" FILES ${OPENNI2_GRABBER_INCLUDES} ${OPENNI2_INCLUDES} ${IMAGE_INCLUDES})
      source_group("OpenNI 2\\Source Files" FILES ${OPENNI2_GRABBER_SOURCES} ${IMAGE_SOURCES})

        # Copy OpenNI2 redist directory to bin. Needed for driver modules. Only tested on Windows.
        if(MSVC)
            file(COPY ${OPENNI2_REDIST_DIR} DESTINATION ${CMAKE_BINARY_DIR}/bin PATTERN *.*)
        endif(MSVC)
    endif()

    if(WITH_OPENNI)
        set(OPENNI_GRABBER_INCLUDES
            include/pcl/io/openni_grabber.h
            include/pcl/io/oni_grabber.h
            )
        set(OPENNI_INCLUDES
            include/pcl/io/openni_camera/openni_shift_to_depth_conversion.h
            include/pcl/io/openni_camera/openni.h
            include/pcl/io/openni_camera/openni_depth_image.h
            include/pcl/io/openni_camera/openni_device.h
            include/pcl/io/openni_camera/openni_device_kinect.h
            include/pcl/io/openni_camera/openni_device_primesense.h
            include/pcl/io/openni_camera/openni_device_xtion.h
            include/pcl/io/openni_camera/openni_device_oni.h
            include/pcl/io/openni_camera/openni_driver.h
            include/pcl/io/openni_camera/openni_exception.h
            include/pcl/io/openni_camera/openni_image.h
            include/pcl/io/openni_camera/openni_image_bayer_grbg.h
            include/pcl/io/openni_camera/openni_image_yuv_422.h
            include/pcl/io/openni_camera/openni_image_rgb24.h
            include/pcl/io/openni_camera/openni_ir_image.h
           ${IMAGE_INCLUDES}
        )
        set(OPENNI_GRABBER_SOURCES
            src/openni_camera/openni_device.cpp
            src/openni_camera/openni_device_primesense.cpp
            src/openni_camera/openni_image_bayer_grbg.cpp
            src/openni_camera/openni_depth_image.cpp
            src/openni_camera/openni_ir_image.cpp
            src/openni_camera/openni_device_kinect.cpp
            src/openni_camera/openni_device_xtion.cpp
            src/openni_camera/openni_device_oni.cpp
            src/openni_camera/openni_driver.cpp
            src/openni_camera/openni_exception.cpp
            src/openni_camera/openni_image_yuv_422.cpp
            src/openni_camera/openni_image_rgb24.cpp
            src/openni_grabber.cpp
            src/oni_grabber.cpp
            ${IMAGE_SOURCES}
        )
    endif()

    source_group("Image Headers" FILES ${IMAGE_INCLUDES})
    source_group("Image Sources" FILES ${IMAGE_SOURCES})

    if(WITH_FZAPI)
        set(FZAPI_GRABBER_INCLUDES
            include/pcl/io/fotonic_grabber.h
            )
#        set(FZAPI_INCLUDES
#            include/pcl/io/openni_camera/openni.h
#            )
        set(FZAPI_GRABBER_SOURCES
            src/fotonic_grabber.cpp
            )
    endif()

    if(WITH_ENSENSO)
        set(ENSENSO_GRABBER_INCLUDES
            include/pcl/io/ensenso_grabber.h
            )
        set(ENSENSO_GRABBER_SOURCES
            src/ensenso_grabber.cpp
            )
    endif()

    if(WITH_DAVIDSDK AND VTK_FOUND) # VTK is mandatory for OBJ/PLY/STL input/output
        set(DAVIDSDK_GRABBER_INCLUDES
            include/pcl/io/davidsdk_grabber.h
            )
        set(DAVIDSDK_GRABBER_SOURCES
            src/davidsdk_grabber.cpp
            )
    endif()

    if(WITH_DSSDK)
        set(DSSDK_GRABBER_INCLUDES
            include/pcl/io/depth_sense_grabber.h
        )
        set(DSSDK_GRABBER_SOURCES
            src/depth_sense_grabber.cpp
            src/depth_sense/depth_sense_grabber_impl.cpp
            src/depth_sense/depth_sense_device_manager.cpp
        )
    endif()

    if(WITH_RSSDK)
        set(RSSDK_GRABBER_INCLUDES
            include/pcl/io/real_sense_grabber.h
        )
        set(RSSDK_GRABBER_SOURCES
            src/real_sense_grabber.cpp
            src/real_sense/real_sense_device_manager.cpp
        )
    endif()

    if(LIBUSB_1_FOUND)
        set(DINAST_GRABBER_INCLUDES
            include/pcl/io/dinast_grabber.h
           )
        set(DINAST_GRABBER_SOURCES
            src/dinast_grabber.cpp
           )
    endif(LIBUSB_1_FOUND)

    if (VTK_FOUND AND NOT ANDROID)
        set(VTK_USE_FILE "${VTK_USE_FILE}" CACHE INTERNAL "VTK_USE_FILE")
        include("${VTK_USE_FILE}")
        set(VTK_IO_INCLUDES
            "include/pcl/${SUBSYS_NAME}/vtk_lib_io.h"
            "include/pcl/${SUBSYS_NAME}/png_io.h"
           )
        set(VTK_IO_INCLUDES_IMPL
            "include/pcl/${SUBSYS_NAME}/impl/vtk_lib_io.hpp"
           )
        set(VTK_IO_SOURCE
            src/vtk_lib_io.cpp
            src/png_io.cpp
           )
        set(VTK_IO_TARGET_LINK_LIBRARIES vtkCommon vtkWidgets vtkIO vtkImaging vtkHybrid vtkGraphics vtkRendering vtkFiltering vtkVolumeRendering)
        # Indicates that we can rely on VTK to be present
        set(VTK_DEFINES -DPCL_BUILT_WITH_VTK)
    endif ()

    set(PLY_SOURCES src/ply/ply_parser.cpp)
    set(PLY_INCLUDES
        "include/pcl/${SUBSYS_NAME}/ply/byte_order.h"
        "include/pcl/${SUBSYS_NAME}/ply/io_operators.h"
        "include/pcl/${SUBSYS_NAME}/ply/ply.h"
        "include/pcl/${SUBSYS_NAME}/ply/ply_parser.h"
       )
    PCL_ADD_LIBRARY(pcl_io_ply "${SUBSYS_NAME}" ${PLY_SOURCES} ${PLY_INCLUDES})
    PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/ply" ${PLY_INCLUDES})

    set(srcs
        src/debayer.cpp
        src/pcd_grabber.cpp
        src/pcd_io.cpp
        src/vtk_io.cpp
        src/ply_io.cpp
        src/ascii_io.cpp
        src/compression.cpp
        src/lzf.cpp
        src/lzf_image_io.cpp
        src/obj_io.cpp
        src/ifs_io.cpp
        src/image_grabber.cpp
        src/hdl_grabber.cpp
        src/vlp_grabber.cpp
        src/robot_eye_grabber.cpp
        src/file_io.cpp
        src/auto_io.cpp
        src/io_exception.cpp
        ${VTK_IO_SOURCE}
        ${OPENNI_GRABBER_SOURCES}
        ${OPENNI2_GRABBER_SOURCES}
        ${IMAGE_SOURCES}
        ${DINAST_GRABBER_SOURCES}
        ${FZAPI_GRABBER_SOURCES}
        ${ENSENSO_GRABBER_SOURCES}
        ${DAVIDSDK_GRABBER_SOURCES}
        ${DSSDK_GRABBER_SOURCES}
        ${RSSDK_GRABBER_SOURCES}
        )
    if(PNG_FOUND)
      list(APPEND srcs
          src/libpng_wrapper.cpp
          )
    endif(PNG_FOUND)

	if(PCAP_FOUND)
	  set(PCAP_DEFINES -DHAVE_PCAP)
          include_directories(${PCAP_INCLUDE_DIRS})
	  add_definitions(${PCAP_DEFINES})
	endif(PCAP_FOUND)

    set(incs
        "include/pcl/${SUBSYS_NAME}/boost.h"
        "include/pcl/${SUBSYS_NAME}/eigen.h"
        "include/pcl/${SUBSYS_NAME}/debayer.h"
        "include/pcl/${SUBSYS_NAME}/file_io.h"
        "include/pcl/${SUBSYS_NAME}/auto_io.h"
        "include/pcl/${SUBSYS_NAME}/lzf.h"
        "include/pcl/${SUBSYS_NAME}/lzf_image_io.h"
        "include/pcl/${SUBSYS_NAME}/io.h"
        "include/pcl/${SUBSYS_NAME}/grabber.h"
        "include/pcl/${SUBSYS_NAME}/file_grabber.h"
        "include/pcl/${SUBSYS_NAME}/pcd_grabber.h"
        "include/pcl/${SUBSYS_NAME}/pcd_io.h"
        "include/pcl/${SUBSYS_NAME}/vtk_io.h"
        "include/pcl/${SUBSYS_NAME}/ply_io.h"
        "include/pcl/${SUBSYS_NAME}/tar.h"
        "include/pcl/${SUBSYS_NAME}/obj_io.h"
        "include/pcl/${SUBSYS_NAME}/ascii_io.h"
        "include/pcl/${SUBSYS_NAME}/ifs_io.h"
        "include/pcl/${SUBSYS_NAME}/image_grabber.h"
        "include/pcl/${SUBSYS_NAME}/hdl_grabber.h"
        "include/pcl/${SUBSYS_NAME}/vlp_grabber.h"
        "include/pcl/${SUBSYS_NAME}/robot_eye_grabber.h"
        "include/pcl/${SUBSYS_NAME}/point_cloud_image_extractors.h"
        "include/pcl/${SUBSYS_NAME}/io_exception.h"
        ${VTK_IO_INCLUDES}
        ${OPENNI_GRABBER_INCLUDES}
        ${OPENNI2_GRABBER_INCLUDES}
        ${IMAGE_INCLUDES}
        ${DINAST_GRABBER_INCLUDES}
        ${FZAPI_GRABBER_INCLUDES}
        ${ENSENSO_GRABBER_INCLUDES}
        ${DAVIDSDK_GRABBER_INCLUDES}
        ${DSSDK_GRABBER_INCLUDES}
        ${RSSDK_GRABBER_INCLUDES}
        "include/pcl/${SUBSYS_NAME}/pxc_grabber.h"  # contains only depreciation note
        )

    set(compression_incs
        include/pcl/compression/octree_pointcloud_compression.h
        include/pcl/compression/color_coding.h
        include/pcl/compression/compression_profiles.h
        include/pcl/compression/entropy_range_coder.h
        include/pcl/compression/point_coding.h
       )
    if(PNG_FOUND)
      list(APPEND compression_incs
          include/pcl/compression/organized_pointcloud_conversion.h
          include/pcl/compression/libpng_wrapper.h
          )
      if(WITH_OPENNI OR WITH_OPENNI2)
        list(APPEND compression_incs
          include/pcl/compression/organized_pointcloud_compression.h
          )
      endif()
    endif(PNG_FOUND)

    set(impl_incs
        "include/pcl/${SUBSYS_NAME}/impl/pcd_io.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/auto_io.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/lzf_image_io.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/synchronized_queue.hpp"
        "include/pcl/${SUBSYS_NAME}/impl/point_cloud_image_extractors.hpp"
        include/pcl/compression/impl/entropy_range_coder.hpp
        include/pcl/compression/impl/octree_pointcloud_compression.hpp
        ${VTK_IO_INCLUDES_IMPL}
       )
    if(PNG_FOUND AND (WITH_OPENNI OR WITH_OPENNI2))
     list(APPEND impl_incs
         include/pcl/compression/impl/organized_pointcloud_compression.hpp
        )
    endif()

    set(LIB_NAME "pcl_${SUBSYS_NAME}")

    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include" ${VTK_INCLUDE_DIRECTORIES})
    add_definitions(${VTK_DEFINES})
    PCL_ADD_LIBRARY("${LIB_NAME}" "${SUBSYS_NAME}" ${srcs} ${incs} ${compression_incs} ${impl_incs} ${OPENNI_INCLUDES} ${OPENNI2_INCLUDES})
    link_directories(${VTK_LINK_DIRECTORIES})
    target_link_libraries("${LIB_NAME}" pcl_common pcl_io_ply ${VTK_LIBRARIES} )
    if(PNG_FOUND)
      target_link_libraries("${LIB_NAME}" ${PNG_LIBRARIES})
    endif(PNG_FOUND)

    if(LIBUSB_1_FOUND)
      target_link_libraries("${LIB_NAME}" ${LIBUSB_1_LIBRARIES})
    endif(LIBUSB_1_FOUND)

=== test/CMakeLists.txt ===
set(SUBSYS_NAME global_tests)
set(SUBSYS_DESC "Point cloud library global unit tests")

if(BUILD_visualization)
  include("${VTK_USE_FILE}")
  set(SUBSYS_DEPS 2d common sample_consensus io kdtree features filters geometry keypoints search surface registration segmentation octree recognition people outofcore visualization)
  set(OPT_DEPS vtk)
else()
  set(SUBSYS_DEPS 2d common sample_consensus io kdtree features filters geometry keypoints search surface registration segmentation octree recognition people outofcore)
endif()

set(DEFAULT OFF)
set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ${DEFAULT} "${REASON}")
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} OPT_DEPS ${OPT_DEPS})

if(build)

    find_package(Gtest REQUIRED)
    include_directories(SYSTEM ${GTEST_INCLUDE_DIRS} ${GTEST_SRC_DIR})

    add_library(pcl_gtest STATIC ${GTEST_SRC_DIR}/src/gtest-all.cc)
	
    if( MSVC11 ) # VS2012 doesn't correctly support variadic templates yet
        add_definitions("-D_VARIADIC_MAX=10")
    endif()

    enable_testing()
    include_directories(${PCL_INCLUDE_DIRS})

    add_custom_target(tests "${CMAKE_CTEST_COMMAND}" "-V" VERBATIM)

    add_subdirectory(2d)
    add_subdirectory(common)
    add_subdirectory(features)
    add_subdirectory(filters)
    add_subdirectory(geometry)
    add_subdirectory(io)
    add_subdirectory(kdtree)
    add_subdirectory(octree)
    add_subdirectory(outofcore)
    add_subdirectory(registration)
    add_subdirectory(search)
    add_subdirectory(keypoints)
    add_subdirectory(surface)
    add_subdirectory(segmentation)
    add_subdirectory(sample_consensus)

	  PCL_ADD_TEST(a_recognition_ism_test test_recognition_ism
                 FILES test_recognition_ism.cpp
                 LINK_WITH pcl_gtest pcl_io pcl_features
                 ARGUMENTS "${PCL_SOURCE_DIR}/test/ism_train.pcd" "${PCL_SOURCE_DIR}/test/ism_test.pcd")

    PCL_ADD_TEST(search test_search
                 FILES test_search.cpp
                 LINK_WITH pcl_gtest pcl_search pcl_io pcl_kdtree
                 ARGUMENTS "${PCL_SOURCE_DIR}/test/table_scene_mug_stereo_textured.pcd")

    PCL_ADD_TEST(a_transforms_test test_transforms
                 FILES test_transforms.cpp
                 LINK_WITH pcl_gtest pcl_io
                 ARGUMENTS "${PCL_SOURCE_DIR}/test/bun0.pcd")
    
    PCL_ADD_TEST(a_segmentation_test test_segmentation
                 FILES test_segmentation.cpp
                 LINK_WITH pcl_gtest pcl_io pcl_segmentation pcl_features pcl_kdtree pcl_search pcl_common
                 ARGUMENTS "${PCL_SOURCE_DIR}/test/bun0.pcd" "${PCL_SOURCE_DIR}/test/car6.pcd" "${PCL_SOURCE_DIR}/test/colored_cloud.pcd")
    
    PCL_ADD_TEST(test_non_linear test_non_linear
                 FILES test_non_linear.cpp
                 LINK_WITH pcl_gtest pcl_common pcl_io pcl_sample_consensus pcl_segmentation pcl_kdtree pcl_search 
                 ARGUMENTS "${PCL_SOURCE_DIR}/test/noisy_slice_displaced.pcd")

    PCL_ADD_TEST(a_recognition_cg_test test_recognition_cg
                 FILES test_recognition_cg.cpp
                 LINK_WITH pcl_gtest pcl_common pcl_io pcl_kdtree pcl_features pcl_recognition pcl_keypoints
                 ARGUMENTS "${PCL_SOURCE_DIR}/test/milk.pcd" "${PCL_SOURCE_DIR}/test/milk_cartoon_all_small_clorox.pcd")

    PCL_ADD_TEST(a_people_detection_test test_people_detection
                 FILES test_people_groundBasedPeopleDetectionApp.cpp
                 LINK_WITH pcl_gtest pcl_common pcl_io pcl_kdtree pcl_search pcl_features pcl_sample_consensus pcl_filters pcl_io pcl_segmentation pcl_people
                 ARGUMENTS "${PCL_SOURCE_DIR}/people/data/trainedLinearSVMForPeopleDetectionWithHOG.yaml" "${PCL_SOURCE_DIR}/test/five_people.pcd")

    if(BUILD_visualization AND (NOT UNIX OR (UNIX AND DEFINED ENV{DISPLAY})))
        PCL_ADD_TEST(a_visualization_test test_visualization
                 FILES test_visualization.cpp
                 LINK_WITH pcl_gtest pcl_io pcl_visualization pcl_features
                 ARGUMENTS "${PCL_SOURCE_DIR}/test/bunny.pcd")
    endif()

endif(build)

=== test/2d/CMakeLists.txt ===
PCL_ADD_TEST(test_2d test_2d FILES test_2d.cpp 
             LINK_WITH pcl_io pcl_gtest
             ARGUMENTS "${PCL_SOURCE_DIR}/test/2d/lena.pcd"
                       "${PCL_SOURCE_DIR}/test/2d/gauss_smooth.pcd"
                       "${PCL_SOURCE_DIR}/test/2d/erosion.pcd"
                       "${PCL_SOURCE_DIR}/test/2d/dilation.pcd"
                       "${PCL_SOURCE_DIR}/test/2d/opening.pcd"
                       "${PCL_SOURCE_DIR}/test/2d/closing.pcd"
                       "${PCL_SOURCE_DIR}/test/2d/erosion_binary.pcd"
                       "${PCL_SOURCE_DIR}/test/2d/dilation_binary.pcd"
                       "${PCL_SOURCE_DIR}/test/2d/opening_binary.pcd"
                       "${PCL_SOURCE_DIR}/test/2d/closing_binary.pcd"
                       "${PCL_SOURCE_DIR}/test/2d/canny.pcd")

=== test/common/CMakeLists.txt ===
# Args: name, executable_name
PCL_ADD_TEST(common_test_wrappers test_wrappers FILES test_wrappers.cpp LINK_WITH pcl_gtest pcl_common)
PCL_ADD_TEST(common_test_macros test_macros FILES test_macros.cpp LINK_WITH pcl_gtest pcl_common)
PCL_ADD_TEST(common_vector_average test_vector_average FILES test_vector_average.cpp LINK_WITH pcl_gtest)
PCL_ADD_TEST(common_common test_common FILES test_common.cpp LINK_WITH pcl_gtest pcl_common)
PCL_ADD_TEST(common_geometry test_geometry FILES test_geometry.cpp LINK_WITH pcl_gtest pcl_common)
PCL_ADD_TEST(common_copy_point test_copy_point FILES test_copy_point.cpp LINK_WITH pcl_gtest pcl_common)
PCL_ADD_TEST(common_centroid test_centroid FILES test_centroid.cpp LINK_WITH pcl_gtest pcl_common)
PCL_ADD_TEST(common_int test_plane_intersection FILES test_plane_intersection.cpp LINK_WITH pcl_gtest pcl_common)
PCL_ADD_TEST(common_pca test_pca FILES test_pca.cpp LINK_WITH pcl_gtest pcl_common)
#PCL_ADD_TEST(common_spring test_spring FILES test_spring.cpp LINK_WITH pcl_gtest pcl_common)
PCL_ADD_TEST(common_gaussian test_gaussian FILES test_gaussian.cpp LINK_WITH pcl_gtest pcl_common)
PCL_ADD_TEST(common_operators test_operators FILES test_operators.cpp LINK_WITH pcl_gtest pcl_common)
#PCL_ADD_TEST(common_convolution test_convolution FILES test_convolution.cpp LINK_WITH pcl_gtest pcl_common)
PCL_ADD_TEST(common_eigen test_eigen FILES test_eigen.cpp LINK_WITH pcl_gtest pcl_common)
PCL_ADD_TEST(common_intensity test_intensity FILES test_intensity.cpp LINK_WITH pcl_gtest pcl_common)
PCL_ADD_TEST(common_generator test_generator FILES test_generator.cpp LINK_WITH pcl_gtest pcl_common)
PCL_ADD_TEST(common_io test_common_io FILES test_io.cpp LINK_WITH pcl_gtest pcl_common)
PCL_ADD_TEST(common_copy_make_borders test_copy_make_borders FILES test_copy_make_borders.cpp LINK_WITH pcl_gtest pcl_common)
PCL_ADD_TEST(common_bearing_angle_image test_bearing_angle_image FILES test_bearing_angle_image.cpp LINK_WITH pcl_gtest pcl_common)

PCL_ADD_TEST(common_point_type_conversion test_common_point_type_conversion FILES test_point_type_conversion.cpp LINK_WITH pcl_gtest pcl_common)

=== test/features/CMakeLists.txt ===
PCL_ADD_TEST(features_ptr test_features_ptr
             FILES test_ptr.cpp
             LINK_WITH pcl_gtest pcl_features)

PCL_ADD_TEST(feature_base test_base_feature
             FILES test_base_feature.cpp
             LINK_WITH pcl_gtest pcl_features pcl_io
             ARGUMENTS "${PCL_SOURCE_DIR}/test/bun0.pcd")
PCL_ADD_TEST(feature_cppf_estimation test_cppf_estimation
             FILES test_cppf_estimation.cpp
             LINK_WITH pcl_gtest pcl_features pcl_io
             ARGUMENTS "${PCL_SOURCE_DIR}/test/colored_cloud.pcd")
PCL_ADD_TEST(feature_normal_estimation test_normal_estimation
             FILES test_normal_estimation.cpp
             LINK_WITH pcl_gtest pcl_features pcl_io
             ARGUMENTS "${PCL_SOURCE_DIR}/test/bun0.pcd")
PCL_ADD_TEST(feature_pfh_estimation test_pfh_estimation
             FILES test_pfh_estimation.cpp
             LINK_WITH pcl_gtest pcl_features pcl_io
             ARGUMENTS "${PCL_SOURCE_DIR}/test/bun0.pcd")

PCL_ADD_TEST(feature_cvfh_estimation test_cvfh_estimation
             FILES test_cvfh_estimation.cpp
             LINK_WITH pcl_gtest pcl_features pcl_io pcl_filters
             ARGUMENTS "${PCL_SOURCE_DIR}/test/bun0.pcd" "${PCL_SOURCE_DIR}/test/milk.pcd")

PCL_ADD_TEST(feature_ppf_estimation test_ppf_estimation
             FILES test_ppf_estimation.cpp
             LINK_WITH pcl_gtest pcl_features pcl_io
             ARGUMENTS "${PCL_SOURCE_DIR}/test/bun0.pcd")
PCL_ADD_TEST(feature_shot_estimation test_shot_estimation
             FILES test_shot_estimation.cpp
             LINK_WITH pcl_gtest pcl_features pcl_io
             ARGUMENTS "${PCL_SOURCE_DIR}/test/bun0.pcd")
PCL_ADD_TEST(feature_boundary_estimation test_boundary_estimation
             FILES test_boundary_estimation.cpp
             LINK_WITH pcl_gtest pcl_features pcl_io
             ARGUMENTS "${PCL_SOURCE_DIR}/test/bun0.pcd")
PCL_ADD_TEST(feature_curvatures_estimation test_curvatures_estimation
             FILES test_curvatures_estimation.cpp
             LINK_WITH pcl_gtest pcl_features pcl_io
             ARGUMENTS "${PCL_SOURCE_DIR}/test/bun0.pcd")
PCL_ADD_TEST(feature_spin_estimation test_spin_estimation
             FILES test_spin_estimation.cpp
             LINK_WITH pcl_gtest pcl_features pcl_io
             ARGUMENTS "${PCL_SOURCE_DIR}/test/bun0.pcd")
PCL_ADD_TEST(feature_rsd_estimation test_rsd_estimation
             FILES test_rsd_estimation.cpp
             LINK_WITH pcl_gtest pcl_features pcl_io pcl_kdtree
             ARGUMENTS "${PCL_SOURCE_DIR}/test/bun0.pcd")
PCL_ADD_TEST(feature_grsd_estimation test_grsd_estimation
             FILES test_grsd_estimation.cpp
             LINK_WITH pcl_gtest pcl_features pcl_io pcl_kdtree
             ARGUMENTS "${PCL_SOURCE_DIR}/test/bun0.pcd")
PCL_ADD_TEST(feature_invariants_estimation test_invariants_estimation
             FILES test_invariants_estimation.cpp
             LINK_WITH pcl_gtest pcl_features pcl_io
             ARGUMENTS "${PCL_SOURCE_DIR}/test/bun0.pcd")
PCL_ADD_TEST(feature_gradient_estimation test_gradient_estimation
             FILES test_gradient_estimation.cpp
             LINK_WITH pcl_gtest pcl_features)
PCL_ADD_TEST(feature_rift_estimation test_rift_estimation
             FILES test_rift_estimation.cpp
             LINK_WITH pcl_gtest pcl_features)
PCL_ADD_TEST(feature_board_estimation test_board_estimation
             FILES test_board_estimation.cpp
             LINK_WITH pcl_gtest pcl_features pcl_io
             ARGUMENTS "${PCL_SOURCE_DIR}/test/bun0.pcd")
PCL_ADD_TEST(feature_shot_lrf_estimation test_shot_lrf_estimation
             FILES test_shot_lrf_estimation.cpp
             LINK_WITH pcl_gtest pcl_features pcl_io
             ARGUMENTS "${PCL_SOURCE_DIR}/test/bun0.pcd")
PCL_ADD_TEST(feature_brisk test_brisk
             FILES test_brisk.cpp
             LINK_WITH pcl_gtest pcl_io pcl_kdtree pcl_filters pcl_keypoints pcl_common pcl_features pcl_search
             ARGUMENTS "${PCL_SOURCE_DIR}/test/brisk_image_gt.pcd" "${PCL_SOURCE_DIR}/test/brisk_keypoints_gt.pcd" "${PCL_SOURCE_DIR}/test/brisk_descriptors_gt.pcd")
PCL_ADD_TEST(features_narf test_narf
             FILES test_narf.cpp
             LINK_WITH pcl_gtest pcl_features ${FLANN_LIBRARIES})
PCL_ADD_TEST(a_ii_normals_test test_ii_normals
             FILES test_ii_normals.cpp
             LINK_WITH pcl_gtest pcl_io pcl_features
             ARGUMENTS "${PCL_SOURCE_DIR}/test/table_scene_mug_stereo_textured.pcd")
PCL_ADD_TEST(feature_moment_of_inertia_estimation test_moment_of_inertia_estimation
             FILES test_moment_of_inertia_estimation.cpp
             LINK_WITH pcl_gtest pcl_io pcl_features
             ARGUMENTS "${PCL_SOURCE_DIR}/test/lamppost.pcd")
PCL_ADD_TEST(feature_rops_estimation test_rops_estimation
             FILES test_rops_estimation.cpp
             LINK_WITH pcl_gtest pcl_io pcl_features
             ARGUMENTS "${PCL_SOURCE_DIR}/test/rops_cloud.pcd" "${PCL_SOURCE_DIR}/test/rops_indices.txt" "${PCL_SOURCE_DIR}/test/rops_triangles.txt")

=== test/io/CMakeLists.txt ===
PCL_ADD_TEST(io_io test_io
              FILES test_io.cpp
              LINK_WITH pcl_gtest pcl_io)

PCL_ADD_TEST(io_iterators test_iterators
              FILES test_iterators.cpp
              LINK_WITH pcl_gtest pcl_io)

PCL_ADD_TEST(compression_range_coder test_range_coder
          FILES test_range_coder.cpp
          LINK_WITH pcl_gtest pcl_io)

PCL_ADD_TEST (io_grabbers test_grabbers
              FILES test_grabbers.cpp
              LINK_WITH pcl_gtest pcl_io
              ARGUMENTS "${PCL_SOURCE_DIR}/test/grabber_sequences")
# Uses VTK readers to verify            
if (VTK_FOUND AND NOT ANDROID)
  PCL_ADD_TEST (io_ply_mesh_io test_ply_mesh_io
                FILES test_ply_mesh_io.cpp
                LINK_WITH pcl_gtest pcl_io
                ARGUMENTS "${PCL_SOURCE_DIR}/test/tum_rabbit.vtk")
endif ()

PCL_ADD_TEST(point_cloud_image_extractors test_point_cloud_image_extractors
             FILES test_point_cloud_image_extractors.cpp
             LINK_WITH pcl_gtest pcl_io)

PCL_ADD_TEST(buffers test_buffers
             FILES test_buffers.cpp
             LINK_WITH pcl_gtest)

=== test/registration/CMakeLists.txt ===
PCL_ADD_TEST(a_registration_test test_registration
             FILES test_registration.cpp
             LINK_WITH pcl_gtest pcl_io pcl_registration pcl_features pcl_search pcl_kdtree pcl_kdtree
             ARGUMENTS "${PCL_SOURCE_DIR}/test/bun0.pcd" "${PCL_SOURCE_DIR}/test/bun4.pcd" "${PCL_SOURCE_DIR}/test/milk_color.pcd")

PCL_ADD_TEST(registration_api test_registration_api
             FILES test_registration_api.cpp test_registration_api_data.h
             LINK_WITH pcl_gtest pcl_io pcl_registration pcl_features pcl_kdtree
             ARGUMENTS "${PCL_SOURCE_DIR}/test/bun0.pcd" "${PCL_SOURCE_DIR}/test/bun4.pcd")
           
PCL_ADD_TEST(registration_warp_api test_warps
             FILES test_warps.cpp 
             LINK_WITH pcl_gtest pcl_io pcl_registration)

PCL_ADD_TEST(correspondence_estimation test_correspondence_estimation
             FILES test_correspondence_estimation.cpp
             LINK_WITH pcl_gtest pcl_io pcl_registration pcl_features)

PCL_ADD_TEST(correspondence_rejectors test_correspondence_rejectors
             FILES test_correspondence_rejectors.cpp
             LINK_WITH pcl_gtest pcl_io pcl_registration pcl_features
             ARGUMENTS "${PCL_SOURCE_DIR}/test/bunny.pcd")

PCL_ADD_TEST(fpcs_ia test_fpcs_ia
             FILES test_fpcs_ia.cpp test_fpcs_ia_data.h
             LINK_WITH pcl_gtest pcl_io pcl_registration pcl_features pcl_search pcl_kdtree
             ARGUMENTS "${PCL_SOURCE_DIR}/test/bun0.pcd" "${PCL_SOURCE_DIR}/test/bun4.pcd")
             
PCL_ADD_TEST(kfpcs_ia test_kfpcs_ia
	     FILES test_kfpcs_ia.cpp test_kfpcs_ia_data.h
	     LINK_WITH pcl_gtest pcl_io pcl_registration pcl_features pcl_search pcl_kdtree
	     ARGUMENTS "${PCL_SOURCE_DIR}/test/office1_keypoints.pcd" "${PCL_SOURCE_DIR}/test/office2_keypoints.pcd")

=== test/sample_consensus/CMakeLists.txt ===
PCL_ADD_TEST(sample_consensus test_sample_consensus
             FILES test_sample_consensus.cpp
             LINK_WITH pcl_gtest pcl_sample_consensus)

PCL_ADD_TEST(sample_consensus_plane_models test_sample_consensus_plane_models
             FILES test_sample_consensus_plane_models.cpp
             LINK_WITH pcl_gtest pcl_io pcl_sample_consensus
             ARGUMENTS "${PCL_SOURCE_DIR}/test/sac_plane_test.pcd")

PCL_ADD_TEST(sample_consensus_quadric_models test_sample_consensus_quadric_models
             FILES test_sample_consensus_quadric_models.cpp
             LINK_WITH pcl_gtest pcl_sample_consensus)

PCL_ADD_TEST(sample_consensus_line_models test_sample_consensus_line_models
             FILES test_sample_consensus_line_models.cpp
             LINK_WITH pcl_gtest pcl_sample_consensus)

=== test/segmentation/CMakeLists.txt ===
# Random walker requires Eigen::Sparse module that is available since 3.1.0
if(NOT ("${EIGEN_VERSION}" VERSION_LESS 3.1.0))
  PCL_ADD_TEST(random_walker test_random_walker
               FILES test_random_walker.cpp
               LINK_WITH pcl_gtest
               ARGUMENTS "${PCL_SOURCE_DIR}/test/segmentation/data")
endif()

=== debian/changelog ===
pcl (1.8.0+dfsg1-4+deb9u1) stretch; urgency=medium

  * Add dependency to libvtk6-qt-dev (Closes: #894656)

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 05 May 2018 14:52:44 +0200

pcl (1.8.0+dfsg1-3) unstable; urgency=medium

  * Disable QT on arm (Closes: #835292)

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 04 Sep 2016 09:30:23 +0200

pcl (1.8.0+dfsg1-2) unstable; urgency=medium

  * Remove superfluous libpcl1.8 package
  * Add patch for empty 2d lib

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 22 Aug 2016 07:46:30 +0200

pcl (1.8.0+dfsg1-1) experimental; urgency=medium

  * Imported Upstream version 1.8.0+dfsg1
  * Rebase patches
  * Add patch for removed non free code
  * Reworked debian/ files
  * Add patch for privacy-breach-logo

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 16 Aug 2016 19:25:49 +0200

=== debian/control ===
Source: pcl
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Thomas Moulard <thomas.moulard@gmail.com>,
	   Jochen Sprickerhof <jspricke@debian.org>,
	   Leopold Palomo-Avellaneda <leo@alaxarxa.net>
Section: libs
Priority: extra
Build-Depends: debhelper (>= 9), dh-exec (>=0.3),
               cmake,
	       python-sphinx,
	       libboost-system-dev,
	       libboost-filesystem-dev,
	       libboost-thread-dev, 
	       libboost-date-time-dev,
	       libboost-iostreams-dev,
	       libeigen3-dev,
	       libflann-dev,
	       libvtk6-dev,
	       libqhull-dev,
	       libopenni-dev [!s390x !alpha !hppa !hurd-i386 !kfreebsd-any !m68k !sh4 !sparc64],
	       libopenni2-dev [!armel !hppa !hurd-i386 !kfreebsd-any !m68k !powerpcspe],
	       libqt5opengl5-dev [!armel !armhf],
	       libusb-1.0-0-dev,
	       freeglut3-dev, 
	       libxmu-dev,
	       libxi-dev,
	       libvtk6-qt-dev [!armel !armhf]
Build-Depends-Indep: doxygen,
		     doxygen-latex
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/pcl.git
Vcs-Git: https://anonscm.debian.org/cgit/debian-science/packages/pcl.git
Homepage: http://www.pointclouds.org/

Package: libpcl-dev
Architecture: any
Section: libdevel
Depends: libboost-all-dev,
	 libeigen3-dev,
	 libflann-dev,
	 libvtk6-dev,
	 libqhull-dev,
	 libvtk6-qt-dev [!armel !armhf],
	 libopenni-dev [!s390x !alpha !hppa !hurd-i386 !kfreebsd-any !m68k !sh4 !sparc64],
	 libopenni2-dev [!armel !hppa !hurd-i386 !kfreebsd-any !m68k !powerpcspe],
	 libpcl-apps1.8 (= ${binary:Version}),
	 libpcl-common1.8 (= ${binary:Version}),
	 libpcl-features1.8 (= ${binary:Version}),
	 libpcl-filters1.8 (= ${binary:Version}),
	 libpcl-io1.8 (= ${binary:Version}),
	 libpcl-kdtree1.8 (= ${binary:Version}),
	 libpcl-keypoints1.8 (= ${binary:Version}),
	 libpcl-ml1.8 (= ${binary:Version}),
	 libpcl-octree1.8 (= ${binary:Version}),
	 libpcl-outofcore1.8 (= ${binary:Version}),
	 libpcl-people1.8 (= ${binary:Version}),
	 libpcl-recognition1.8 (= ${binary:Version}),
	 libpcl-registration1.8 (= ${binary:Version}),
	 libpcl-sample-consensus1.8 (= ${binary:Version}),
	 libpcl-search1.8 (= ${binary:Version}),
	 libpcl-segmentation1.8 (= ${binary:Version}),
	 libpcl-stereo1.8 (= ${binary:Version}),
	 libpcl-surface1.8 (= ${binary:Version}),
	 libpcl-tracking1.8 (= ${binary:Version}),
	 libpcl-visualization1.8 (= ${binary:Version}),
	 ${misc:Depends}
Suggests: libpcl-doc
Description: Point Cloud Library - development files
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains development files (headers and shared library
 symbolic link).

Package: libpcl-apps1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - apps library
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications depending 
 on PCL apps.

Package: libpcl-common1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - common library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL common library.

Package: libpcl-features1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - features library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL features library.

Package: libpcl-filters1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - filters library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL filters library.

Package: libpcl-io1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - I/O library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the libraries needed to run applications 
 depending on PCL io.

Package: libpcl-kdtree1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - kdtree library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL kdtree library.

Package: libpcl-keypoints1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - keypoints library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL keypoints library.

Package: libpcl-ml1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - ml library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL ml library.

Package: libpcl-octree1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - octree library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL octree library.

Package: libpcl-outofcore1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, 
	 ${misc:Depends}
Description: Point Cloud Library - outofcore library
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications 
 depending on PCL outofcore.

Package: libpcl-people1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, 
	 ${misc:Depends}
Description: Point Cloud Library - people library
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications 
 depending on PCL people.

Package: libpcl-recognition1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, 
    	 ${misc:Depends}
Description: Point Cloud Library - recognition library
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications 
 depending on PCL recognition.

Package: libpcl-registration1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - registration library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL registration library.

Package: libpcl-sample-consensus1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - sample consensus library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL sample consensus library.

Package: libpcl-search1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - search library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL search library.

Package: libpcl-segmentation1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - segmentation library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL segmentation library.

Package: libpcl-stereo1.8
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - stereo library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .

=== debian/rules ===
#!/usr/bin/make -f

# Hardening.
export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

DEB_BUILD_ARCH     ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
ifneq (,$(filter $(DEB_BUILD_ARCH),mips mipsel))
	CXXFLAGS+=--param ggc-min-expand=20
endif

BUILD_DOC = $(if $(shell dh_listpackages | grep libpcl-doc),-DWITH_DOCS=ON)

# Multiarch.
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
# Num bits
DEB_HOST_ARCH_BITS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_BITS)

ifeq ($(DEB_HOST_ARCH_BITS),32)
  PARALLEL=
else
  PARALLEL=--parallel
endif

.PHONY: override_dh_auto_configure \
	override_dh_install \
	override_dh_installchangelogs

override_dh_auto_configure:
	dh_auto_configure -- 						\
	-DLIB_INSTALL_DIR:STRING="lib/$(DEB_HOST_MULTIARCH)"		\
	-DCMAKE_SKIP_RPATH=ON						\
	-DBUILD_TESTS=OFF -DBUILD_apps=ON -DBUILD_common=ON		\
	-DBUILD_examples=ON -DBUILD_features=ON -DBUILD_filters=ON	\
	-DBUILD_geometry=ON -DBUILD_global_tests=OFF -DBUILD_io=ON	\
	-DBUILD_kdtree=ON -DBUILD_keypoints=ON -DBUILD_octree=ON	\
	-DBUILD_registration=ON -DBUILD_sample_consensus=ON		\
	-DBUILD_search=ON -DBUILD_segmentation=ON -DBUILD_surface=ON	\
	-DBUILD_tools=ON -DBUILD_tracking=ON -DBUILD_visualization=ON   \
	-DBUILD_apps_cloud_composer=OFF -DBUILD_apps_modeler=ON            \
	-DBUILD_apps_point_cloud_editor=ON -DBUILD_apps_in_hand_scanner=ON \
	$(BUILD_DOC)

override_dh_install:
	@for i in pcl_concatenate_points_pcd pcl_grabcut_2d \
		pcl_elch pcl_dinast_grabber pcl_hdl_grabber \
		pcl_icp pcl_icp2d pcl_lum pcl_manual_registration pcl_match_linemod_template \
		pcl_multiscale_feature_persistence_example pcl_ndt2d pcl_ndt3d pcl_ni_agast \
		pcl_ni_linemod pcl_ni_susan pcl_nn_classification_example \
		pcl_obj_rec_ransac_hash_table pcl_openni_grabber_depth_example \
		pcl_openni_grabber_example pcl_openni_mobile_server \
		pcl_openni_organized_multi_plane_segmentation \
		pcl_openni_passthrough pcl_openni_shift_to_depth_conversion \
		pcl_openni_voxel_grid pcl_organized_segmentation_demo pcl_outofcore_print \
		pcl_outofcore_process pcl_pcd_image_viewer \
		pcl_pcd_organized_multi_plane_segmentation pcl_pcd_video_player \
		pcl_point_cloud_editor pcl_pyramid_surface_matching pcl_radius_filter \
		pcl_statistical_multiscale_interest_region_extraction_example \
		pcl_registration_visualizer pcl_surfel_smoothing_test \
		pcl_timed_trigger_test pcl_viewer pcl_virtual_scanner \
		pcl_voxel_grid_occlusion_estimation pcl_compute_hausdorff \
		pcl_generate pcl_grid_min pcl_in_hand_scanner pcl_local_max \
		pcl_morph pcl_ni_trajkovic pcl_obj2pcd pcl_offline_integration 	\
		pcl_openni_klt pcl_progressive_morphological_filter \
		pcl_converter pcl_crf_segmentation pcl_face_trainer pcl_fs_face_detector \
		pcl_ni_brisk pcl_obj2ply pcl_openni_face_detector \
		pcl_openni_organized_edge_detection pcl_outofcore_viewer \
		pcl_pcd_introduce_nan pcl_pcd_organized_edge_detection \
		pcl_stereo_ground_segmentation pcl_train_unary_classifier \
		pcl_unary_classifier_segment pcl_vlp_viewer pcl_openni2_viewer \
		pcl_openni_organized_multi_plane_segmentation; do \
	cmd="dh_link -p pcl-tools usr/share/man/man1/pcl_pointclouds.1 usr/share/man/man1/$$i.1"; \
	echo $$cmd; $$cmd; \
	done
		
	dh_install --list-missing

#override_dh_shlibdeps:
#	dh_shlibdeps -v -Xusr/bin/pcl_* -Lpcl-tools -l:$(CURDIR)/debian/usr/lib/${DEB_HOST_MULTIARCH}/cloud_composer_plugins: -ppcl --- -xpcl-tools -v

override_dh_installchangelogs:
	dh_installchangelogs -plibpcl-common1.8 CHANGES.md
	# Creating dh_links to share the same file
	@for i in libpcl-dev libpcl1.8 libpcl-apps1.8 \
		libpcl-features1.8 libpcl-filters1.8 libpcl-io1.8 libpcl-kdtree1.8 \
		libpcl-keypoints1.8 libpcl-octree1.8 libpcl-outofcore1.8 libpcl-people1.8 \
		libpcl-recognition1.8 libpcl-registration1.8 libpcl-sample-consensus1.8 \
		libpcl-search1.8 libpcl-segmentation1.8 libpcl-stereo1.8 \
		libpcl-surface1.8 libpcl-tracking1.8 libpcl-visualization1.8 \
		pcl-tools libpcl-doc; do \
	cmd="dh_link -p$$i usr/share/doc/libpcl-common1.8/changelog.gz usr/share/doc/$$i/changelog.gz"; \
	echo $$cmd; $$cmd; \
	done
	dh_installchangelogs


%:
	dh  $@ $(PARALLEL) --builddirectory=build


get-orig-source:
	uscan --verbose --force-download --repack --compress xz

=== debian/watch ===
# Watch control file for uscan
version=3
#opts=uversionmangle=s/(\d)[_.+-]?((RC|rc|pre|dev|beta|alpha)[\d.]*)$/$1~$2/ \ 
#https://github.com/PointCloudLibrary/pcl/releases .*/pcl-(\d\S*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

opts="repacksuffix=+dfsg,dversionmangle=s/(\d)[_.+-]?((RC|rc|pre|dev|beta|alpha)[\d.]*)$/$1~$2+dfsg/" \
https://github.com/PointCloudLibrary/pcl/releases .*/pcl-(\d\S*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
